diff --git a/lib/compat-wrapper.c b/lib/compat-wrapper.c
new file mode 100644
index 0000000..1d3b24d
--- /dev/null
+++ b/lib/compat-wrapper.c
@@ -0,0 +1,263 @@
+#include <config.h>
+#include <string.h>
+
+#define LIBTASN1_COMPAT_WRAPPER
+#include "libtasn1-internal.h"
+
+#include "libtasn1.h"
+
+asn1_retCode
+asn1_parser2tree (const char *file_name,
+		  ASN1_TYPE  *definitions,
+		  char       *errorDescription)
+{
+	return asn1_internal_parser2tree (file_name, definitions, errorDescription);
+}
+
+asn1_retCode
+asn1_parser2array (const char *inputFileName,
+		   const char *outputFileName,
+		   const char *vectorName,
+		   char       *errorDescription)
+{
+	return asn1_internal_parser2array (inputFileName, outputFileName, vectorName, errorDescription);
+}
+
+asn1_retCode
+asn1_array2tree (const ASN1_ARRAY_TYPE * array,
+		 ASN1_TYPE * definitions,
+		 char *errorDescription)
+{
+	return asn1_internal_array2tree (array, definitions, errorDescription);
+}
+
+void
+asn1_print_structure (FILE       *out,
+		      ASN1_TYPE   structure,
+		      const char *name,
+		      int         mode)
+{
+	asn1_internal_print_structure (out, structure, name, mode);
+}
+
+asn1_retCode
+asn1_create_element (ASN1_TYPE   definitions,
+		     const char *source_name,
+		     ASN1_TYPE  *element)
+{
+	return asn1_internal_create_element (definitions, source_name, element);
+}
+
+asn1_retCode
+asn1_delete_structure (ASN1_TYPE *structure)
+{
+	return asn1_internal_delete_structure (structure);
+}
+
+asn1_retCode
+asn1_delete_element (ASN1_TYPE   structure,
+		     const char *element_name)
+{
+	return asn1_internal_delete_element (structure, element_name);
+}
+
+asn1_retCode
+asn1_write_value (ASN1_TYPE   node_root,
+		  const char *name,
+		  const void *ivalue,
+		  int         len)
+{
+	return asn1_internal_write_value (node_root, name, ivalue, len);
+}
+
+asn1_retCode
+asn1_read_value (ASN1_TYPE   root,
+		 const char *name,
+		 void       *ivalue,
+		 int        *len)
+{
+	return asn1_internal_read_value (root, name, ivalue, len);
+}
+
+asn1_retCode
+asn1_number_of_elements (ASN1_TYPE   element,
+			 const char *name,
+			 int        *num)
+{
+	return asn1_internal_number_of_elements (element, name, num);
+}
+
+asn1_retCode
+asn1_der_coding (ASN1_TYPE   element,
+		 const char *name,
+		 void       *ider,
+		 int        *len,
+		 char       *ErrorDescription)
+{
+	return asn1_internal_der_coding (element, name, ider, len, ErrorDescription);
+}
+
+asn1_retCode
+asn1_der_decoding (ASN1_TYPE  *element,
+		   const void *ider,
+		   int         len,
+		   char       *errorDescription)
+{
+	return asn1_internal_der_decoding (element, ider, len, errorDescription);
+}
+
+asn1_retCode
+asn1_der_decoding_element (ASN1_TYPE  *structure,
+			   const char *elementName,
+			   const void *ider,
+			   int         len,
+			   char       *errorDescription)
+{
+	return asn1_internal_der_decoding_element (structure, elementName, ider, len, errorDescription);
+}
+
+asn1_retCode
+asn1_der_decoding_startEnd (ASN1_TYPE   element,
+			    const void *ider,
+			    int         len,
+			    const char *name_element,
+			    int        *start,
+			    int        *end)
+{
+	return asn1_internal_der_decoding_startEnd (element, ider, len, name_element, start, end);
+}
+
+asn1_retCode
+asn1_expand_any_defined_by (ASN1_TYPE  definitions,
+			    ASN1_TYPE *element)
+{
+	return asn1_internal_expand_any_defined_by (definitions, element);
+}
+
+asn1_retCode
+asn1_expand_octet_string (ASN1_TYPE   definitions,
+			  ASN1_TYPE  *element,
+			  const char *octetName,
+			  const char *objectName)
+{
+	return asn1_internal_expand_octet_string (definitions, element, octetName, objectName);
+}
+
+asn1_retCode
+asn1_read_tag (node_asn   *root,
+	       const char *name,
+	       int        *tagValue,
+	       int        *classValue)
+{
+	return asn1_internal_read_tag (root, name, tagValue, classValue);
+}
+
+const char *
+asn1_find_structure_from_oid (ASN1_TYPE   definitions,
+			      const char *oidValue)
+{
+	return asn1_internal_find_structure_from_oid (definitions, oidValue);
+}
+
+const char *
+asn1_check_version (const char *req_version)
+{
+	if (!req_version || strverscmp (req_version, LIBTASN1_VERSION) <= 0)
+		return LIBTASN1_VERSION;
+
+	return NULL;
+}
+
+const char *
+libtasn1_strerror (asn1_retCode error)
+{
+	return asn1_internal_strerror (error);
+}
+
+void
+libtasn1_perror (asn1_retCode error)
+{
+	asn1_internal_perror (error);
+}
+
+int
+asn1_get_tag_der (const unsigned char *der,
+		  int                  der_len,
+		  unsigned char       *cls,
+		  int                 *len,
+		  unsigned long       *tag)
+{
+	return asn1_internal_get_tag_der (der, der_len, cls, len, tag);
+}
+
+void
+asn1_octet_der (const unsigned char *str,
+		int                  str_len,
+		unsigned char       *der,
+		int                 *der_len)
+{
+	asn1_internal_octet_der (str, str_len, der, der_len);
+}
+
+asn1_retCode
+asn1_get_octet_der (const unsigned char *der,
+		    int			 der_len,
+		    int			*ret_len,
+		    unsigned char	*str,
+		    int			 str_size,
+		    int			*str_len)
+{
+	return asn1_internal_get_octet_der (der, der_len, ret_len, str, str_size, str_len);
+}
+
+void
+asn1_bit_der (const unsigned char *str,
+	      int		   bit_len,
+	      unsigned char	  *der,
+	      int		  *der_len)
+{
+	asn1_internal_bit_der (str, bit_len, der, der_len);
+}
+
+asn1_retCode
+asn1_get_bit_der (const unsigned char *der,
+		  int		       der_len,
+		  int		      *ret_len,
+		  unsigned char	      *str,
+		  int		       str_size,
+		  int		      *bit_len)
+{
+	return asn1_internal_get_bit_der (der, der_len, ret_len, str, str_size, bit_len);
+}
+
+signed long
+asn1_get_length_der (const unsigned char *der,
+		     int		  der_len,
+		     int		 *len)
+{
+	return asn1_internal_get_length_der (der, der_len, len);
+}
+
+void
+asn1_length_der (unsigned long int  len,
+		 unsigned char     *ans,
+		 int               *ans_len)
+{
+	asn1_internal_length_der (len, ans, ans_len);
+}
+
+ASN1_TYPE
+asn1_find_node (ASN1_TYPE   pointer,
+		const char *name)
+{
+	return asn1_internal_find_node (pointer, name);
+}
+
+asn1_retCode
+asn1_copy_node (ASN1_TYPE   dst,
+		const char *dst_name,
+		ASN1_TYPE   src,
+		const char *src_name)
+{
+	return asn1_internal_copy_node (dst, dst_name, src, src_name);
+}
diff --git a/lib/decoding.c b/lib/decoding.c
index 53bd910..c452496 100644
--- a/lib/decoding.c
+++ b/lib/decoding.c
@@ -77,7 +77,7 @@ _asn1_error_description_tag_error (asn1_node node, char *ErrorDescription)
  *   when the decoded length value plus @len would exceed @der_len.
  **/
 long
-asn1_get_length_der (const unsigned char *der, int der_len, int *len)
+asn1_internal_get_length_der (const unsigned char *der, int der_len, int *len)
 {
   unsigned int ans;
   int k, punt, sum;
@@ -145,8 +145,8 @@ asn1_get_length_der (const unsigned char *der, int der_len, int *len)
  * Returns: Returns %ASN1_SUCCESS on success, or an error.
  **/
 int
-asn1_get_tag_der (const unsigned char *der, int der_len,
-		  unsigned char *cls, int *len, unsigned long *tag)
+asn1_internal_get_tag_der (const unsigned char *der, int der_len,
+			   unsigned char *cls, int *len, unsigned long *tag)
 {
   unsigned int ris;
   int punt;
@@ -215,12 +215,12 @@ asn1_get_tag_der (const unsigned char *der, int der_len,
  * Since: 2.0
  **/
 long
-asn1_get_length_ber (const unsigned char *ber, int ber_len, int *len)
+asn1_internal_get_length_ber (const unsigned char *ber, int ber_len, int *len)
 {
   int ret;
   long err;
 
-  ret = asn1_get_length_der (ber, ber_len, len);
+  ret = asn1_internal_get_length_der (ber, ber_len, len);
   if (ret == -1)
     {				/* indefinite length method */
       err = _asn1_get_indefinite_length_string (ber + 1, ber_len, &ret);
@@ -245,16 +245,16 @@ asn1_get_length_ber (const unsigned char *ber, int ber_len, int *len)
  * Returns: Returns %ASN1_SUCCESS on success, or an error.
  **/
 int
-asn1_get_octet_der (const unsigned char *der, int der_len,
-		    int *ret_len, unsigned char *str, int str_size,
-		    int *str_len)
+asn1_internal_get_octet_der (const unsigned char *der, int der_len,
+			     int *ret_len, unsigned char *str, int str_size,
+			     int *str_len)
 {
   int len_len = 0;
 
   if (der_len <= 0)
     return ASN1_GENERIC_ERROR;
 
-  *str_len = asn1_get_length_der (der, der_len, &len_len);
+  *str_len = asn1_internal_get_length_der (der, der_len, &len_len);
 
   if (*str_len < 0)
     return ASN1_DER_ERROR;
@@ -284,7 +284,7 @@ _asn1_get_time_der (const unsigned char *der, int der_len, int *ret_len,
   if (der_len <= 0 || str == NULL)
     return ASN1_DER_ERROR;
 
-  str_len = asn1_get_length_der (der, der_len, &len_len);
+  str_len = asn1_internal_get_length_der (der, der_len, &len_len);
   if (str_len <= 0 || str_size < str_len)
     return ASN1_DER_ERROR;
 
@@ -311,7 +311,7 @@ _asn1_get_objectid_der (const unsigned char *der, int der_len, int *ret_len,
   if (str == NULL || der_len <= 0)
     return ASN1_GENERIC_ERROR;
 
-  len = asn1_get_length_der (der, der_len, &len_len);
+  len = asn1_internal_get_length_der (der, der_len, &len_len);
 
   if (len <= 0 || len + len_len > der_len)
     return ASN1_DER_ERROR;
@@ -371,16 +371,16 @@ _asn1_get_objectid_der (const unsigned char *der, int der_len, int *ret_len,
  * Returns: Return %ASN1_SUCCESS on success, or an error.
  **/
 int
-asn1_get_bit_der (const unsigned char *der, int der_len,
-		  int *ret_len, unsigned char *str, int str_size,
-		  int *bit_len)
+asn1_internal_get_bit_der (const unsigned char *der, int der_len,
+			   int *ret_len, unsigned char *str, int str_size,
+			   int *bit_len)
 {
   int len_len = 0, len_byte;
 
   if (der_len <= 0)
     return ASN1_GENERIC_ERROR;
 
-  len_byte = asn1_get_length_der (der, der_len, &len_len) - 1;
+  len_byte = asn1_internal_get_length_der (der, der_len, &len_len) - 1;
   if (len_byte < 0)
     return ASN1_DER_ERROR;
 
@@ -437,7 +437,7 @@ _asn1_extract_tag_der (asn1_node node, const unsigned char *der, int der_len,
 
 	      if (p->type & CONST_EXPLICIT)
 		{
-		  if (asn1_get_tag_der
+		  if (asn1_internal_get_tag_der
 		      (der + counter, der_len, &class, &len2,
 		       &tag) != ASN1_SUCCESS)
 		    return ASN1_DER_ERROR;
@@ -446,7 +446,7 @@ _asn1_extract_tag_der (asn1_node node, const unsigned char *der, int der_len,
 		  counter += len2;
 
 		  len3 =
-		    asn1_get_length_ber (der + counter, der_len,
+		    asn1_internal_get_length_ber (der + counter, der_len,
 					 &len2);
 		  if (len3 < 0)
 		    return ASN1_DER_ERROR;
@@ -488,7 +488,7 @@ _asn1_extract_tag_der (asn1_node node, const unsigned char *der, int der_len,
 
   if (is_tag_implicit)
     {
-      if (asn1_get_tag_der
+      if (asn1_internal_get_tag_der
 	  (der + counter, der_len, &class, &len2,
 	   &tag) != ASN1_SUCCESS)
 	return ASN1_DER_ERROR;
@@ -516,7 +516,7 @@ _asn1_extract_tag_der (asn1_node node, const unsigned char *der, int der_len,
 	  return ASN1_SUCCESS;
 	}
 
-      if (asn1_get_tag_der
+      if (asn1_internal_get_tag_der
 	  (der + counter, der_len, &class, &len2,
 	   &tag) != ASN1_SUCCESS)
 	return ASN1_DER_ERROR;
@@ -624,7 +624,7 @@ _asn1_delete_not_used (asn1_node node)
 	      if (!p2)
 		p2 = _asn1_find_up (p);
 	    }
-	  asn1_delete_structure (&p);
+	  asn1_internal_delete_structure (&p);
 	  p = p2;
 	}
 
@@ -671,7 +671,7 @@ _asn1_extract_der_octet (asn1_node node, const unsigned char *der,
   int counter, counter_end;
   int result;
 
-  len2 = asn1_get_length_der (der, der_len, &len3);
+  len2 = asn1_internal_get_length_der (der, der_len, &len3);
   if (len2 < -1)
     return ASN1_DER_ERROR;
 
@@ -684,7 +684,7 @@ _asn1_extract_der_octet (asn1_node node, const unsigned char *der,
 
   while (counter < counter_end)
     {
-      len2 = asn1_get_length_der (der + counter, der_len, &len3);
+      len2 = asn1_internal_get_length_der (der + counter, der_len, &len3);
 
       if (len2 < -1)
 	return ASN1_DER_ERROR;
@@ -726,7 +726,7 @@ _asn1_get_octet_string (asn1_node node, const unsigned char *der, int der_len, i
   if (*(der - 1) & ASN1_CLASS_STRUCTURED)
     {
       tot_len = 0;
-      indefinite = asn1_get_length_der (der, der_len, &len3);
+      indefinite = asn1_internal_get_length_der (der, der_len, &len3);
       if (indefinite < -1)
 	return ASN1_DER_ERROR;
 
@@ -759,7 +759,7 @@ _asn1_get_octet_string (asn1_node node, const unsigned char *der, int der_len, i
 
 	  counter++;
 
-	  len2 = asn1_get_length_der (der + counter, der_len, &len3);
+	  len2 = asn1_internal_get_length_der (der + counter, der_len, &len3);
 	  if (len2 <= 0)
 	    return ASN1_DER_ERROR;
 
@@ -777,7 +777,7 @@ _asn1_get_octet_string (asn1_node node, const unsigned char *der, int der_len, i
 
 	  len2 = sizeof (temp);
 
-	  asn1_length_der (tot_len, temp, &len2);
+	  asn1_internal_length_der (tot_len, temp, &len2);
 	  _asn1_set_value (node, temp, len2);
 
 	  ret = _asn1_extract_der_octet (node, der, der_len);
@@ -788,7 +788,7 @@ _asn1_get_octet_string (asn1_node node, const unsigned char *der, int der_len, i
     }
   else
     {				/* NOT STRUCTURED */
-      len2 = asn1_get_length_der (der, der_len, &len3);
+      len2 = asn1_internal_get_length_der (der, der_len, &len3);
       if (len2 < 0)
 	return ASN1_DER_ERROR;
 
@@ -830,7 +830,7 @@ _asn1_get_indefinite_length_string (const unsigned char *der,
 	    continue;
 	}
 
-      if (asn1_get_tag_der
+      if (asn1_internal_get_tag_der
 	  (der + counter, der_len, &class, &len2,
 	   &tag) != ASN1_SUCCESS)
 	return ASN1_DER_ERROR;
@@ -838,7 +838,7 @@ _asn1_get_indefinite_length_string (const unsigned char *der,
       DECR_LEN(der_len, len2);
       counter += len2;
 
-      len2 = asn1_get_length_der (der + counter, der_len, &len3);
+      len2 = asn1_internal_get_length_der (der + counter, der_len, &len3);
       if (len2 < -1)
 	return ASN1_DER_ERROR;
 
@@ -869,7 +869,7 @@ static void delete_unneeded_choice_fields(asn1_node p)
   while (p->right)
     {
       p2 = p->right;
-      asn1_delete_structure (&p2);
+      asn1_internal_delete_structure (&p2);
     }
 }
 
@@ -895,7 +895,7 @@ static void delete_unneeded_choice_fields(asn1_node p)
  *   name (*@ELEMENT deleted).
  **/
 int
-asn1_der_decoding (asn1_node * element, const void *ider, int ider_len,
+asn1_internal_der_decoding (asn1_node * element, const void *ider, int ider_len,
 		   char *errorDescription)
 {
   asn1_node node, p, p2, p3;
@@ -996,7 +996,7 @@ asn1_der_decoding (asn1_node * element, const void *ider, int ider_len,
 		    move = UP;
 
 		  if (p->type & CONST_OPTION)
-		    asn1_delete_structure (&p);
+		    asn1_internal_delete_structure (&p);
 
 		  p = p2;
 		  continue;
@@ -1025,7 +1025,7 @@ asn1_der_decoding (asn1_node * element, const void *ider, int ider_len,
 		  else
 		    {
 		      p2 = p->down;
-		      asn1_delete_structure (&p2);
+		      asn1_internal_delete_structure (&p2);
 		    }
 		}
 
@@ -1117,7 +1117,7 @@ asn1_der_decoding (asn1_node * element, const void *ider, int ider_len,
 	    case ASN1_ETYPE_INTEGER:
 	    case ASN1_ETYPE_ENUMERATED:
 	      len2 =
-		asn1_get_length_der (der + counter, ider_len, &len3);
+		asn1_internal_get_length_der (der + counter, ider_len, &len3);
 	      if (len2 < 0)
 		{
 		  result = ASN1_DER_ERROR;
@@ -1193,7 +1193,7 @@ asn1_der_decoding (asn1_node * element, const void *ider, int ider_len,
 	    case ASN1_ETYPE_VISIBLE_STRING:
 	    case ASN1_ETYPE_BIT_STRING:
 	      len2 =
-		asn1_get_length_der (der + counter, ider_len, &len3);
+		asn1_internal_get_length_der (der + counter, ider_len, &len3);
 	      if (len2 < 0)
 		{
 		  result = ASN1_DER_ERROR;
@@ -1238,7 +1238,7 @@ asn1_der_decoding (asn1_node * element, const void *ider, int ider_len,
 	      else
 		{		/* move==DOWN || move==RIGHT */
 		  len3 =
-		    asn1_get_length_der (der + counter, ider_len, &len2);
+		    asn1_internal_get_length_der (der + counter, ider_len, &len2);
 		  if (len3 < -1)
 		    {
 		      result = ASN1_DER_ERROR;
@@ -1265,7 +1265,7 @@ asn1_der_decoding (asn1_node * element, const void *ider, int ider_len,
 			  if (type_field (p2->type) != ASN1_ETYPE_TAG)
 			    {
 			      p3 = p2->right;
-			      asn1_delete_structure (&p2);
+			      asn1_internal_delete_structure (&p2);
 			      p2 = p3;
 			    }
 			  else
@@ -1325,7 +1325,7 @@ asn1_der_decoding (asn1_node * element, const void *ider, int ider_len,
 	      else
 		{		/* move==DOWN || move==RIGHT */
 		  len3 =
-		    asn1_get_length_der (der + counter, ider_len, &len2);
+		    asn1_internal_get_length_der (der + counter, ider_len, &len2);
 		  if (len3 < -1)
 		    {
 		      result = ASN1_DER_ERROR;
@@ -1361,7 +1361,7 @@ asn1_der_decoding (asn1_node * element, const void *ider, int ider_len,
 	      move = RIGHT;
 	      break;
 	    case ASN1_ETYPE_ANY:
-	      if (asn1_get_tag_der
+	      if (asn1_internal_get_tag_der
 		  (der + counter, ider_len, &class, &len2,
 		   &tag) != ASN1_SUCCESS)
 		{
@@ -1373,7 +1373,7 @@ asn1_der_decoding (asn1_node * element, const void *ider, int ider_len,
 	      DECR_LEN(ider_len, len2);
 
 	      len4 =
-		asn1_get_length_der (der + counter + len2,
+		asn1_internal_get_length_der (der + counter + len2,
 				     ider_len, &len3);
 	      if (len4 < -1)
 		{
@@ -1476,7 +1476,7 @@ asn1_der_decoding (asn1_node * element, const void *ider, int ider_len,
   return ASN1_SUCCESS;
 
 cleanup:
-  asn1_delete_structure (element);
+  asn1_internal_delete_structure (element);
   return result;
 }
 
@@ -1510,7 +1510,7 @@ cleanup:
  *   match the structure @structure (*ELEMENT deleted).
  **/
 int
-asn1_der_decoding_element (asn1_node * structure, const char *elementName,
+asn1_internal_der_decoding_element (asn1_node * structure, const char *elementName,
 			   const void *ider, int len, char *errorDescription)
 {
   asn1_node node, p, p2, p3, nodeFound = NULL;
@@ -1637,7 +1637,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 		    move = UP;
 
 		  if (p->type & CONST_OPTION)
-		    asn1_delete_structure (&p);
+		    asn1_internal_delete_structure (&p);
 
 		  p = p2;
 		  continue;
@@ -1667,7 +1667,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 		  else
 		    {
 		      p2 = p->down;
-		      asn1_delete_structure (&p2);
+		      asn1_internal_delete_structure (&p2);
 		    }
 		}
 
@@ -1762,7 +1762,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 	    case ASN1_ETYPE_INTEGER:
 	    case ASN1_ETYPE_ENUMERATED:
 	      len2 =
-		asn1_get_length_der (der + counter, len - counter, &len3);
+		asn1_internal_get_length_der (der + counter, len - counter, &len3);
 	      if (len2 < 0)
 		{
 		  result = ASN1_DER_ERROR;
@@ -1804,7 +1804,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 	      else
 		{
 		  len2 =
-		    asn1_get_length_der (der + counter, len - counter, &len3);
+		    asn1_internal_get_length_der (der + counter, len - counter, &len3);
 		  if (len2 < 0)
 		    {
 		      result = ASN1_DER_ERROR;
@@ -1836,7 +1836,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 	      else
 		{
 		  len2 =
-		    asn1_get_length_der (der + counter, len - counter, &len3);
+		    asn1_internal_get_length_der (der + counter, len - counter, &len3);
 		  if (len2 < 0)
 		    {
 		      result = ASN1_DER_ERROR;
@@ -1875,7 +1875,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 	    case ASN1_ETYPE_VISIBLE_STRING:
 	    case ASN1_ETYPE_BIT_STRING:
 	      len2 =
-		asn1_get_length_der (der + counter, len - counter, &len3);
+		asn1_internal_get_length_der (der + counter, len - counter, &len3);
 	      if (len2 < 0)
 		{
 		  result = ASN1_DER_ERROR;
@@ -1929,7 +1929,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 		  if (state == OTHER_BRANCH)
 		    {
 		      len3 =
-			asn1_get_length_der (der + counter, len - counter,
+			asn1_internal_get_length_der (der + counter, len - counter,
 					     &len2);
 		      if (len3 < 0)
 			{
@@ -1942,7 +1942,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 		  else
 		    {		/*  state==SAME_BRANCH or state==FOUND */
 		      len3 =
-			asn1_get_length_der (der + counter, len - counter,
+			asn1_internal_get_length_der (der + counter, len - counter,
 					     &len2);
 		      if (len3 < 0)
 			{
@@ -1967,7 +1967,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 			      if (type_field (p2->type) != ASN1_ETYPE_TAG)
 				{
 				  p3 = p2->right;
-				  asn1_delete_structure (&p2);
+				  asn1_internal_delete_structure (&p2);
 				  p2 = p3;
 				}
 			      else
@@ -2012,7 +2012,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 		  if (state == OTHER_BRANCH)
 		    {
 		      len3 =
-			asn1_get_length_der (der + counter, len - counter,
+			asn1_internal_get_length_der (der + counter, len - counter,
 					     &len2);
 		      if (len3 < 0)
 			{
@@ -2025,7 +2025,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 		  else
 		    {		/* state==FOUND or state==SAME_BRANCH */
 		      len3 =
-			asn1_get_length_der (der + counter, len - counter,
+			asn1_internal_get_length_der (der + counter, len - counter,
 					     &len2);
 		      if (len3 < 0)
 			{
@@ -2055,7 +2055,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 
 	      break;
 	    case ASN1_ETYPE_ANY:
-	      if (asn1_get_tag_der
+	      if (asn1_internal_get_tag_der
 		  (der + counter, len - counter, &class, &len2,
 		   &tag) != ASN1_SUCCESS)
 		{
@@ -2070,7 +2070,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
 		}
 
 	      len4 =
-		asn1_get_length_der (der + counter + len2,
+		asn1_internal_get_length_der (der + counter + len2,
 				     len - counter - len2, &len3);
 	      if (len4 < -1)
 		{
@@ -2262,7 +2262,7 @@ asn1_der_decoding_element (asn1_node * structure, const char *elementName,
   return ASN1_SUCCESS;
 
 cleanup:
-  asn1_delete_structure (structure);
+  asn1_internal_delete_structure (structure);
   return result;
 }
 
@@ -2292,7 +2292,7 @@ cleanup:
  *   doesn't match the structure ELEMENT.
  **/
 int
-asn1_der_decoding_startEnd (asn1_node element, const void *ider, int ider_len,
+asn1_internal_der_decoding_startEnd (asn1_node element, const void *ider, int ider_len,
 			    const char *name_element, int *start, int *end)
 {
   asn1_node node, node_to_find, p, p2;
@@ -2307,7 +2307,7 @@ asn1_der_decoding_startEnd (asn1_node element, const void *ider, int ider_len,
   if (node == NULL)
     return ASN1_ELEMENT_NOT_FOUND;
 
-  node_to_find = asn1_find_node (node, name_element);
+  node_to_find = asn1_internal_find_node (node, name_element);
 
   if (node_to_find == NULL)
     return ASN1_ELEMENT_NOT_FOUND;
@@ -2492,7 +2492,7 @@ asn1_der_decoding_startEnd (asn1_node element, const void *ider, int ider_len,
 	    case ASN1_ETYPE_VISIBLE_STRING:
 	    case ASN1_ETYPE_BIT_STRING:
 	      len2 =
-		asn1_get_length_der (der + counter, ider_len, &len3);
+		asn1_internal_get_length_der (der + counter, ider_len, &len3);
 	      if (len2 < 0)
 	        {
 		  warn();
@@ -2508,7 +2508,7 @@ asn1_der_decoding_startEnd (asn1_node element, const void *ider, int ider_len,
 	      if (move != UP)
 		{
 		  len3 =
-		    asn1_get_length_der (der + counter, ider_len, &len2);
+		    asn1_internal_get_length_der (der + counter, ider_len, &len2);
 		  if (len3 < -1)
 		    {
   		      warn();
@@ -2538,7 +2538,7 @@ asn1_der_decoding_startEnd (asn1_node element, const void *ider, int ider_len,
 	      if (move != UP)
 		{
 		  len3 =
-		    asn1_get_length_der (der + counter, ider_len, &len2);
+		    asn1_internal_get_length_der (der + counter, ider_len, &len2);
 		  if (len3 < -1)
 		    {
   		      warn();
@@ -2577,7 +2577,7 @@ asn1_der_decoding_startEnd (asn1_node element, const void *ider, int ider_len,
 	      move = RIGHT;
 	      break;
 	    case ASN1_ETYPE_ANY:
-	      if (asn1_get_tag_der
+	      if (asn1_internal_get_tag_der
 		  (der + counter, ider_len, &class, &len2,
 		   &tag) != ASN1_SUCCESS)
 		 {
@@ -2588,7 +2588,7 @@ asn1_der_decoding_startEnd (asn1_node element, const void *ider, int ider_len,
 	      DECR_LEN(ider_len, len2);
 
 	      len4 =
-		asn1_get_length_der (der + counter + len2,
+		asn1_internal_get_length_der (der + counter + len2,
 				     ider_len, &len3);
 	      if (len4 < -1)
 	        {
@@ -2702,7 +2702,7 @@ cleanup:
  *   depending on DER decoding.
  **/
 int
-asn1_expand_any_defined_by (asn1_node definitions, asn1_node * element)
+asn1_internal_expand_any_defined_by (asn1_node definitions, asn1_node * element)
 {
   char name[2 * ASN1_MAX_NAME_SIZE + 1],
     value[ASN1_MAX_NAME_SIZE];
@@ -2794,7 +2794,7 @@ asn1_expand_any_defined_by (asn1_node definitions, asn1_node * element)
 
 		      len = ASN1_MAX_NAME_SIZE;
 		      result =
-			asn1_read_value (definitions, name, value, &len);
+			asn1_internal_read_value (definitions, name, value, &len);
 
 		      if ((result == ASN1_SUCCESS)
 			  && (!_asn1_strcmp (p3->value, value)))
@@ -2809,18 +2809,18 @@ asn1_expand_any_defined_by (asn1_node definitions, asn1_node * element)
 			      snprintf(name, sizeof(name), "%s.%s", definitionsName, p2->name);
 
 			      result =
-				asn1_create_element (definitions, name, &aux);
+				asn1_internal_create_element (definitions, name, &aux);
 			      if (result == ASN1_SUCCESS)
 				{
 				  _asn1_cpy_name (aux, p);
 				  len2 =
-				    asn1_get_length_der (p->value,
+				    asn1_internal_get_length_der (p->value,
 							 p->value_len, &len3);
 				  if (len2 < 0)
 				    return ASN1_DER_ERROR;
 
 				  result =
-				    asn1_der_decoding (&aux, p->value + len3,
+				    asn1_internal_der_decoding (&aux, p->value + len3,
 						       len2,
 						       errorDescription);
 				  if (result == ASN1_SUCCESS)
@@ -2829,7 +2829,7 @@ asn1_expand_any_defined_by (asn1_node definitions, asn1_node * element)
 				      _asn1_set_right (aux, p->right);
 				      _asn1_set_right (p, aux);
 
-				      result = asn1_delete_structure (&p);
+				      result = asn1_internal_delete_structure (&p);
 				      if (result == ASN1_SUCCESS)
 					{
 					  p = aux;
@@ -2837,20 +2837,20 @@ asn1_expand_any_defined_by (asn1_node definitions, asn1_node * element)
 					  break;
 					}
 				      else
-					{	/* error with asn1_delete_structure */
-					  asn1_delete_structure (&aux);
+					{	/* error with asn1_internal_delete_structure */
+					  asn1_internal_delete_structure (&aux);
 					  retCode = result;
 					  break;
 					}
 				    }
 				  else
-				    {	/* error with asn1_der_decoding */
+				    {	/* error with asn1_internal_der_decoding */
 				      retCode = result;
 				      break;
 				    }
 				}
 			      else
-				{	/* error with asn1_create_element */
+				{	/* error with asn1_internal_create_element */
 				  retCode = result;
 				  break;
 				}
@@ -2930,8 +2930,8 @@ asn1_expand_any_defined_by (asn1_node definitions, asn1_node * element)
  *   use for expansion, or other errors depending on DER decoding.
  **/
 int
-asn1_expand_octet_string (asn1_node definitions, asn1_node * element,
-			  const char *octetName, const char *objectName)
+asn1_internal_expand_octet_string (asn1_node definitions, asn1_node * element,
+				   const char *octetName, const char *objectName)
 {
   char name[2 * ASN1_MAX_NAME_SIZE + 1], value[ASN1_MAX_NAME_SIZE];
   int retCode = ASN1_SUCCESS, result;
@@ -2943,7 +2943,7 @@ asn1_expand_octet_string (asn1_node definitions, asn1_node * element,
   if ((definitions == NULL) || (*element == NULL))
     return ASN1_ELEMENT_NOT_FOUND;
 
-  octetNode = asn1_find_node (*element, octetName);
+  octetNode = asn1_internal_find_node (*element, octetName);
   if (octetNode == NULL)
     return ASN1_ELEMENT_NOT_FOUND;
   if (type_field (octetNode->type) != ASN1_ETYPE_OCTET_STRING)
@@ -2951,7 +2951,7 @@ asn1_expand_octet_string (asn1_node definitions, asn1_node * element,
   if (octetNode->value == NULL)
     return ASN1_VALUE_NOT_FOUND;
 
-  objectNode = asn1_find_node (*element, objectName);
+  objectNode = asn1_internal_find_node (*element, objectName);
   if (objectNode == NULL)
     return ASN1_ELEMENT_NOT_FOUND;
 
@@ -2974,7 +2974,7 @@ asn1_expand_octet_string (asn1_node definitions, asn1_node * element,
 	  strcat (name, p2->name);
 
 	  len = sizeof (value);
-	  result = asn1_read_value (definitions, name, value, &len);
+	  result = asn1_internal_read_value (definitions, name, value, &len);
 
 	  if ((result == ASN1_SUCCESS)
 	      && (!_asn1_strcmp (objectNode->value, value)))
@@ -2991,18 +2991,18 @@ asn1_expand_octet_string (asn1_node definitions, asn1_node * element,
 		  strcat (name, ".");
 		  strcat (name, p2->name);
 
-		  result = asn1_create_element (definitions, name, &aux);
+		  result = asn1_internal_create_element (definitions, name, &aux);
 		  if (result == ASN1_SUCCESS)
 		    {
 		      _asn1_cpy_name (aux, octetNode);
 		      len2 =
-			asn1_get_length_der (octetNode->value,
+			asn1_internal_get_length_der (octetNode->value,
 					     octetNode->value_len, &len3);
 		      if (len2 < 0)
 			return ASN1_DER_ERROR;
 
 		      result =
-			asn1_der_decoding (&aux, octetNode->value + len3,
+			asn1_internal_der_decoding (&aux, octetNode->value + len3,
 					   len2, errorDescription);
 		      if (result == ASN1_SUCCESS)
 			{
@@ -3010,27 +3010,27 @@ asn1_expand_octet_string (asn1_node definitions, asn1_node * element,
 			  _asn1_set_right (aux, octetNode->right);
 			  _asn1_set_right (octetNode, aux);
 
-			  result = asn1_delete_structure (&octetNode);
+			  result = asn1_internal_delete_structure (&octetNode);
 			  if (result == ASN1_SUCCESS)
 			    {
 			      aux = NULL;
 			      break;
 			    }
 			  else
-			    {	/* error with asn1_delete_structure */
-			      asn1_delete_structure (&aux);
+			    {	/* error with asn1_internal_delete_structure */
+			      asn1_internal_delete_structure (&aux);
 			      retCode = result;
 			      break;
 			    }
 			}
 		      else
-			{	/* error with asn1_der_decoding */
+			{	/* error with asn1_internal_der_decoding */
 			  retCode = result;
 			  break;
 			}
 		    }
 		  else
-		    {		/* error with asn1_create_element */
+		    {		/* error with asn1_internal_create_element */
 		      retCode = result;
 		      break;
 		    }
@@ -3067,9 +3067,9 @@ asn1_expand_octet_string (asn1_node definitions, asn1_node * element,
  * Returns: %ASN1_SUCCESS if successful or an error value.
  **/
 int
-asn1_decode_simple_der (unsigned int etype, const unsigned char *der,
-			unsigned int der_len, const unsigned char **str,
-			unsigned int *str_len)
+asn1_internal_decode_simple_der (unsigned int etype, const unsigned char *der,
+				 unsigned int der_len, const unsigned char **str,
+				 unsigned int *str_len)
 {
   int tag_len, len_len;
   const unsigned char *p;
@@ -3088,7 +3088,7 @@ asn1_decode_simple_der (unsigned int etype, const unsigned char *der,
     return ASN1_VALUE_NOT_VALID;
 
   p = der;
-  ret = asn1_get_tag_der (p, der_len, &class, &tag_len, &tag);
+  ret = asn1_internal_get_tag_der (p, der_len, &class, &tag_len, &tag);
   if (ret != ASN1_SUCCESS)
     return ret;
 
@@ -3098,7 +3098,7 @@ asn1_decode_simple_der (unsigned int etype, const unsigned char *der,
   p += tag_len;
   der_len -= tag_len;
 
-  ret = asn1_get_length_der (p, der_len, &len_len);
+  ret = asn1_internal_get_length_der (p, der_len, &len_len);
   if (ret < 0)
     return ASN1_DER_ERROR;
 
